import * as stream from 'stream';
import getDecryptor from '../decryption/decryptChunk';

export default function decryptTransform(decryptionKeys: [number, number, number]): stream.Transform {
  const decryptor = getDecryptor(decryptionKeys);
  const transform = new stream.Transform();
  //TODO: we need to set transform._transform = (chunk) => { return chunk; }
  transform._transform = (chunk, encoding, callback) => {
    const decryptedChunk = decryptor(chunk);
    callback(undefined, decryptedChunk);
  };

  /*transform.on('readable', () => {
    const encryptedChunk = transform.read();

    if (encryptedChunk === null) {
      transform.end();
      return;
    }

    const decryptedChunk = decryptor(encryptedChunk);

    transform.write(decryptedChunk);
  });*/

  return transform;
}
